Last Comment Bug 215296 - Need to restore "- Mozilla Firebird" on Win32
: Need to restore "- Mozilla Firebird" on Win32
Status: VERIFIED FIXED
: access
Product: Firefox
Classification: Client Software
Component: General (show other bugs)
: unspecified
: x86 Windows XP
: -- trivial with 2 votes (vote)
: Firebird0.7
Assigned To: David Hyatt
: Mike Connor [:mconnor]
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2003-08-06 11:01 PDT by Colin Ogilvie [:cso]
Modified: 2009-10-08 02:07 PDT (History)
12 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Patch to check for screen readers and do the right thing with the title. (3.08 KB, patch)
2003-08-11 19:21 PDT, David Hyatt
no flags Details | Diff | Splinter Review
Patch to make only the Mac (and only in Fb/Tb) drop the modifier. (1.74 KB, patch)
2003-08-11 19:48 PDT, David Hyatt
bryner: review+
brendan: superreview+
Details | Diff | Splinter Review

Description Colin Ogilvie [:cso] 2003-08-06 11:01:58 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.5b) Gecko/20030805 Mozilla Firebird/0.6.1+
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.5b) Gecko/20030805 Mozilla Firebird/0.6.1+

The string "Mozilla Firebird" has gone from the titlebar of the browser. This
means it is hard to figure out what the window is.

Reproducible: Always

Steps to Reproduce:
1. Launch Mozilla Firebird
Actual Results:  
Title Bar says "Main Page" (the title of my Home Page)

Expected Results:  
Title Bar should say "Main Page - Mozilla Firebird"
Comment 1 Dean Tessman 2003-08-06 18:33:34 PDT
I talked this over with Hyatt and this was intentional.  After thinking about
it, I agree with him.  The icon already tells you what the application is, and
the " - Mozilla Firebird" at the end of the caption is hardly ever going to
display on the taskbar icon.
Comment 2 amano 2003-08-06 19:47:31 PDT
Yes. Please. Leave it like it's now. It's pretty cool because now your taskbar
already tells you what site is open. It's really a feature, coz I know that it's
firebird (which I'm running).
Comment 3 Nilson Cain 2003-08-06 19:56:58 PDT
Why do you jump to this descision?  David Hyatt is not the only user of this
browser, you know.  I want the title put back, and I suggest you re-open this
bug, as to allow for the community's opinion.
Comment 4 Brendan Eich [:brendan] 2003-08-06 21:28:11 PDT
Please see http://www.mozilla.org/roadmap.html, the paragraph containing 'For
coherent UI within an application, there is no substitute for leadership by an
"application czar".'

Bugs are not the place to rally the community to your side; use newsgroups, vote
for bugs, but do not add advocacy comments to them.

/be
Comment 5 Tom Sommer 2003-08-06 23:28:11 PDT
You still get incidents where there is aboslutely nothing shown in the
titlebar... Like when a tab is loading, to me... It just looks stupid, while it
may be intentional, it makes no sense... Every other program I can think of.
uses the " - Application" It's never bothered anyone, there was no *need* to
remove it...

So while it may be intentional, I think the true purpose of this bug was to
request the 'feature' back, not file it as a "bug"
Comment 6 Mike Connor [:mconnor] 2003-08-07 01:20:53 PDT
verified invalid.
Comment 7 Jesse Ruderman 2003-08-07 01:59:22 PDT
Tom, Dean already filed bug 215353 to cover the case when there's no title.
Comment 8 Colin Ogilvie [:cso] 2003-08-07 02:40:45 PDT
I strongly disagree with not adding it back. Currently, Firebird is the only application that does not seem to have its OWN name in my Taskbar.
Comment 9 Peter Hewitt 2003-08-07 08:59:01 PDT
I'm sorry but this is a really daf thing to do. It makes the program look really
cheap and nasty. I think it looks terrible when there is nothing in the taskbar
at all.

Of course if you are going to do this then add support for coloured scrollbars.
There was a big hoohar about how a webpage should not have control over the
browser but by removing the "- Mozilla Firebird" this is what it seems to be doing.

Every other application I know retains it's own name in the title bar with the
filename either before or after it. Please put it back.
Comment 10 David Hyatt 2003-08-07 10:51:30 PDT
The title bar will display Untitled when the page has no title.  That's a
regression caused by the removal that I will be fixing.  As for the complaints
about the application name being necessary, here is some of the reasoning behind
the decision:

The taskbar has two modes of operation in Windows XP: either similar application
windows are clumped together (by application name), or the old-style Windows
2000 and earlier style can be used, where each window is given its own entry in
the taskbar.  The former is the default in Windows XP, and quite obviously makes
the need for a title utterly unnecessary, since the windows are already grouped
by type.

With the latter, the title rarely shows anyway, so arguing that it is somehow
useful as a means to understand what kind of window you have open is bogus.

Finally, on platforms like the Mac, this convention simply isn't used, and it
resulted in "- Mozilla Firebird" showing up for the items in the Window menu. 
This looked completely ridiculous on the Mac.

Yes, I could #ifdef this change just for Mac, but I don't view this as any great
Windows OS imperative (on my machine plenty of apps have the titlebar addition
and plenty don't, so it's obviously only a guideline and not some holy OS behavior).
Comment 11 Tom Sommer 2003-08-07 11:17:40 PDT
With all due respect, what was wrong with the way it was before?, it worked for
everyone then. Nobody complained, all was good. I would rather have an #ifdef
for Mac, it doesn't seem fair to change this all because of how it looks on Mac.

Having an entry in my taskbar saying "Untitled" makes no sense. The question
"Untitled what?" comes to mind.
Comment 12 David Hyatt 2003-08-07 11:27:58 PDT
I'm going to show the application name when the document has no title (rather
than Untitled).

From a XUL perspective, there's now a new attribute available on <window> called
titledefault that represents the title to use when a document in the window has
no title.
Comment 13 Tom Sommer 2003-08-07 11:33:56 PDT
Fair enough, it's a step in the right direction.

But I still maintain my opinion that this thing should never had happened - If
it ain't broken, don't fix it!
Comment 14 David Hyatt 2003-08-07 11:38:13 PDT
Only it is broken on Mac, and I don't see any reason to clutter up the XUL with
#ifdefs when all platforms can have a consistent single implementation.
Comment 15 whorfin 2003-08-07 11:40:04 PDT
> But I still maintain my opinion that this thing should never had happened - If
> it ain't broken, don't fix it!

It should never have happened because to leave the titlebar on the main frame of
your app completely blank at ANY time is counter to every UI guidline I've ever
read.  It's VERY bad form on all the major platforms (Windoze, Mac, Linux).

This is something I'd like to see fixed ASAP, and the sort of unilateralism I'd
like to see avoided in the future.  I'm trying hard to not be a UI weenie
zealot, but you have to have SOME modicum of following the rules in that area.
Comment 16 Tom Sommer 2003-08-07 11:44:09 PDT
David, I can understand the change if it caused problems on Mac. But that does
not, in my mind, justify making it a global (all OS) change. Windows users have
lived with this 'look' for many many years. Whenever *I* look at the title, I go
"Something is missing"

I don't see any advantages by removing it on windows, none at all... There might
be some on Mac, but it should not affect the look on Linux and Windows.

Just wondering: Would it not only require ONE #ifdef?
Comment 17 Peter Hewitt 2003-08-07 11:44:47 PDT
Surely this is not just to do with the Mac builds?
Plus as for the XP grouping - every UK PC manufacturer I've had experience with
seems to turn it off for their OEMs. I know a lot of people who find it annoying
so I'm not sure how that argument relates to it. You could colour the button
blue automatically but what would happen to people using the non default themes?

I'm not convinved. Is there no way to get this back from about:config or turn it
off just for the mac builds. I mean Autoscroll only exists in Win32.
Comment 18 Dai Toyama 2003-08-07 12:13:09 PDT
When an URL is open, the title of the URL shows up on the menu bar.  When it's a
blank page, however, nothing is displayed.  I honestly believe that looks bad. 
At least when a blank page is displayed, the title "Mozilla Firebird" should be
displayed instead.
Comment 19 shadytrees 2003-08-07 12:14:24 PDT
There was a reason why every other program made for Windows had their app title
in the titlebar, ya know.
Comment 20 Tom Sommer 2003-08-07 12:15:20 PDT
#19: Yeah we sort of already covered that, read the bug....
Comment 21 David Hyatt 2003-08-07 12:24:07 PDT
Everyone please stop posting complaints about the title bar being blank.  That 
was never the intended behavior of this checkin, and is just a bug.  See 
215440 for the fix that is already coming.
Comment 22 MORA 2003-08-07 12:52:31 PDT
Well, I just went through virtually all major applications I'm running on my Windows 2k platform, and NONE, not even the **** ones, tried to hide the name of the application from the title window. In some cases, the application name was preceded by the document title (e.g. in IE and all MS Office products), sometimes it was vice versa (e.g. in TextPad, which uses 'Textpad - [Document1]' for a new document), but I have yet to find one program which does not show the program name at all. 

I think it would be bad for Mozilla Firebird to behave differently. If the standard convention for the Mac is different, then by all means fix this for the Mac, but please stick to the standard conventions when it comes to other platforms. Implementing different behavior just for the sake of it does not make sense, even in view of the cross-platform argument. 

I also believe that removing Mozilla Firebird from the title bar will hurt Mozilla marketing and evangelism efforts. People need to be able to distinguish Firebird from IE, they need to get rid of the idea that IE == 'The Internet'. Hiding (or at least obscuring) Firebird's identity does not help. 
Comment 23 MORA 2003-08-07 12:54:48 PDT
(Apologies for not using hard line-brakes in my previous 
message. I'm still fairly new to Bugzilla; I thought it
would wrap automatically.)
Comment 24 Tom Sommer 2003-08-07 13:01:08 PDT
Comment #22
You make excellent points :)

Comment #23
It normally does, AFAIK. Don't know what went wrong..
Comment 25 Martin Alderson 2003-08-07 13:47:28 PDT
completely agree. Make this a freakin' option in 'advanced options', but DONT
turn it off by default. I will be staying at Moz 0.6.1 until this is fixed.
Comment 26 David Hyatt 2003-08-07 14:10:48 PDT
The blank titlebar problem has been fixed. (bug 215440)
Comment 27 Tom Sommer 2003-08-07 15:12:35 PDT
I guess another argument is that when Firebird and Thunderbird become primary
products, and replaces the Suite. Some won't be able to tell which is which,
since the icons will then change again (posted in a bug somewhere) and become
unified.

Can we PLEASE make this Mac only? All this is because it looks bad on a Mac...

Yeah I know I am whining, I can't stop :(
Comment 28 pantsgolem 2003-08-07 21:23:38 PDT
While I don't know if this is codified in any Windows or Linux UI guide, having
the application title is certainly the "standard."  There are many special
concessions made for the Mac version of Firebird to follow Mac guidelines -- why
should this particular instance warrant a deviation from this practice?  I think
I speak for many here when I say that if I wanted my apps to behave like they do
on a Mac, I'd use a Mac.

As far as the taskbar button goes, not everybody *has* XP (Or KDE, since it can
do the same thing), not everybody uses the grouping feature anyway, and there's
still the title bar, which is what the bug report was originally in reference to
anyway.
Comment 29 Michael Hendy (Hendikins) 2003-08-08 10:02:49 PDT
OK, I'm going to reopen this, even I've been told it will cause an unholy battle
of huge proportions.

May I suggest a look at the following:

"The title bar at the top of a window displays an application-defined icon and
line of text. The text specifies the name of the application and indicates the
purpose of the window." - User Interface Element Reference, Microsoft Active
Accessibility.
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/msaa/msaapndx_9a2a.asp

"Sufficient information about a user interface element including the identity,
operation and state of the element shall be available to assistive technology.
When an image represents a program element, the information conveyed by the
image must also be available in text." - Section 508, § 1194.21 Software
applications and operating systems, Item d.
http://www.section508.gov/index.cfm?FuseAction=Content&ID=12#Software

I knew there was a better reason for commenting than "this is *really* pissing
me off"...
Comment 30 Michael Hendy (Hendikins) 2003-08-08 10:04:16 PDT
...
Comment 31 Mike Connor [:mconnor] 2003-08-08 11:03:36 PDT
Microsoft doesn't make this a hard and fast rule, Windows Explorer doesn't ever
use this, Outlook Express compose and read windows don't, there's an option
somewhere to turn this off in at least in Excel XP (because it sure wasn't on at
IBM).  I could expand the list to others but I won't.  Meeting UI requirements
from a company that doesn't always use them in their own apps doesn't seem like
a big deal, especially if the convention has extremely limited value.

I also personally disagree with the interpretation of section 508(d) in this
regard, since I highly doubt the name of the program should be construed as a
program element, especially as it has no action associated with it.  Also, that
would mean that anything Mac-based could never be used by anyone in the US
federal government.

adjusting severity and modifying summary to reflect the only part of the bug
which is possibly valid.  I don't care much for the MS UI guidelines, but the
section 508 requirement issue needs a legal opinion.  Adding sec508 keyword
provisionally, pending response from legal.
Comment 32 Bill Mason 2003-08-08 11:10:35 PDT
It might also be observed that, if the display of the program name is
considering as falling under accessibility mandates, that the removal for
reasons of cross-platform consistency could be interpreted as permissable under
the W3C User Agent Accessibility Guidelines.

"When faced with a choice between the conventions of different operating
environments, a developer should follow the conventions that most benefit
accessibility, while meeting the developer's design goals. For instance, some
developers may prefer cross-platform consistency over consistency with other
user agents running in a given operating environment, and this might affect
which conventions would be preferred."
http://www.w3.org/TR/UAAG10/conformance.html#content-or-ua

Adding kw access conditionally as well.
Comment 33 Colin Ramsay 2003-08-08 11:36:56 PDT
If someone could please state clearly **why this makes a difference to the
operation and accessibility of the app** (without reference to UI specs and with
meaningful justification), I'm sure Bugzilla would be very greatful.
Comment 34 Colin Ramsay 2003-08-08 11:38:52 PDT
If someone could please state clearly **why this makes a difference to the
operation and accessibility of the app** (without reference to UI specs and with
meaningful justification), I'm sure Bugzilla would be very greatful.
Comment 35 Bill Mason 2003-08-08 14:06:36 PDT
"If someone could please state clearly **why this makes a difference to the
operation and accessibility of the app**"

I'm a theoretical blind computer user.  As is typical of assistive software for
the blind, as I switch from application to application, the software reads the
title bar of the application.  Typically the title bar includes the name of the
application.

As things currently stand, I have no Firebird application name in the title bar.
 I cannot see those wonderful application icons.  I now have to recall the title
of the page I was on to be sure what application I have switched to.  Good luck
to me if I'm on one of these pages:

http://www.google.com/search?q=%22untitled+document%22

While the UAAG may be interpreted as allowing for the current behavior, I think
the previous implementation was more accessible and was working fine cross-platform.

I grant that I am a Windows user, but if the "- Mozilla Firebird" behavior was
really bothering any Mac users outside of the Firebird team, I sure can't find
the bug reports to back that up.  Someone please refer me to a bug number if I
am wrong.

From an accessibility viewpoint, I would argue we should revert back to
Firebird's previous functionality.
Comment 36 David Hyatt 2003-08-08 14:46:03 PDT
--> me
Comment 37 David Hyatt 2003-08-08 14:54:12 PDT
Some points before I close this again:

There is no doubt in my mind that this does not violate accessibility
guidelines.  Windows Explorer (not Internet Explorer but just plain old
Explorer) does not include an "application name" in its title bars, nor do many
other windows apps.  Windows Explorer is obviously not in violation of
accessibility guidelines.

Furthermore, the Internet Explorer titlebar addition gets taken over by ISPs and
the text gets replaced anyway.  The one on the Windows machine I'm using now is
meaningless.  The text has been replaced with my ISP.

This is not done on platforms like the Mac, and it is not seen as a violation of
accessibility guidelines there.  If you don't understand why having the "-
Mozilla Firebird" appended on the Mac is a problem, then you have obviously
never used the Window menu on a Mac before. :)
Comment 38 David Hyatt 2003-08-08 14:56:10 PDT
Do not reopen this.   The decision is final.
Comment 39 Ben Goodger (use ben at mozilla dot org for email) 2003-08-08 14:58:53 PDT
verif.
Comment 40 Peter Hewitt 2003-08-08 15:33:31 PDT
Can I still reply to this thing? Well I'm going to anyways.

I don't agree with Windows Explorer being pulled up as a testcase as it is not
an "application" of sorts - it is the operating system's file and folder viewer
thing. Is this decision purely related to the Mac issue as I cannot seem to find
a definate answer in the replies. If it is - surely it could have just been
edited in the Mac version for Firebird. As cross-platform as FB is there are
differences between the different builds (autoscroll being the most obvious).
Anyways that's my moan for tonight.
Comment 41 Colin Ramsay 2003-08-08 15:37:02 PDT
Please provide reasoning rather that personal opinions here. If referring to
accessibility problems, please refer to specific guidelines or testcases. 

Failing that, stop commenting on this "bug" because you are adding nothing.
Comment 42 David Hyatt 2003-08-08 15:37:46 PDT
Point taken about Explorer, but I can give you plenty of apps that don't do this
as well.  Although I can't verify this, someone said Opera drops the "- Opera"
in paid versions.

I should point out that "- AppName" is not a convention on Linux either.  This
is purely a Windows convention, and IMO not an important enough one to have
#ifdef XP_WIN code for.
Comment 43 Bill Mason 2003-08-08 15:59:53 PDT
I'll say my 2 cents as well before walking away.

"There is no doubt in my mind that this does not violate accessibility
guidelines."

Unless you wish to offer an informed opinion why (yours or anyone else's), at
least just stick to your main point that in your opinion it was broken on a Mac
 previously.

"Windows Explorer (not Internet Explorer but just plain old
Explorer) does not include an "application name" in its title bars, nor do many
other windows apps.  Windows Explorer is obviously not in violation of
accessibility guidelines."

Again, whose informed opinion are you citing to make such a blanket statement?

"Furthermore, the Internet Explorer titlebar addition gets taken over by ISPs
and the text gets replaced anyway.  The one on the Windows machine I'm using now
is meaningless.  The text has been replaced with my ISP."

So because this functionality is broken in other applications, is your
justification?

"This is not done on platforms like the Mac, and it is not seen as a violation
of accessibility guidelines there.  If you don't understand why having the "-
Mozilla Firebird" appended on the Mac is a problem, then you have obviously
never used the Window menu on a Mac before. :)"

I still have not seen anything that shows the Mac Firebird commmunity was having
an issue with this, outside of the Firebird team itself.  Yet the Windows
community already has an extension written to restore the original text of the
titlebar.  Vox populi.

"Point taken about Explorer, but I can give you plenty of apps that don't do
this as well.  Although I can't verify this, someone said Opera drops the "-
Opera" in paid versions."

That is not correct where Opera is concerned.

"I should point out that "- AppName" is not a convention on Linux either.  This
is purely a Windows convention, and IMO not an important enough one to have
#ifdef XP_WIN code for."

So the point is still that to fix a Mac convention, the Windows convention has
been broken.  That seems clear enough.

=====

"Please provide reasoning rather that personal opinions here. If referring to
accessibility problems, please refer to specific guidelines or testcases. 

Failing that, stop commenting on this "bug" because you are adding nothing."

Colin, since several guidelines have already been cited, feel free to remove
yourself from the CC list if you're troubled.
Comment 44 Colin Ramsay 2003-08-08 16:09:13 PDT
Apologies, I should have written "relevant guidelines".

It's been shown by the reference to Windows Apps (explorer, etc) that no
relevant guidelines have been provided. The MS guidelines are ignored by
everyone, why should Firebird follow them?

The *relevant guidelines* would be those published by independant accessibility
experts. The only one I've seen like that is the "section508" one, and I've yet
to see an interpretation of that case for this bug.
Comment 45 Dean Tessman 2003-08-08 16:34:18 PDT
Sigh.  There is no rule in Microsoft's guideline, there is only a suggestion. 
From
http://msdn.microsoft.com/library/en-us/winui/winui/windowsuserinterface/windowing/windows/aboutwindows.asp,
"[t]he title bar displays an application-defined icon and line of text;
typically, the text specifies the name of the application or indicates the
purpose of the window."  Note the key word "typically".
Comment 46 David Hyatt 2003-08-08 16:41:15 PDT
Ok, my main concern here was forcing all XUL authors to have to #ifdef their
windows (which would inevitably just lead to Mac and Linux getting screwed over
by this Windows convention), but I've since thought of a way to avoid this and
to keep the #ifdef XP_WIN in only two places.

So here's an idea:
(1) Back out titledefault
(2) Make the application of titlemodifier be #ifdef XP_WIN in the case where you
have a doctitle, and make it happen everywhere in the case where you don't.

This would keep the #ifdefs in the toolkit and would enable XUL authors to just
write to the Windows convention while keeping everything working on Mac and Linux.

Thoughts?
Comment 47 David Hyatt 2003-08-08 16:45:41 PDT
The fact remains, though, that Firebird's title bar looks better to me even on
Windows without the extra modifier.
Comment 48 amano 2003-08-08 17:20:39 PDT
Referring to #42:

Only because Bill Mason doesn't like the new behaviour, and maybe some others
from mozillazine don't either, that does not mean it's vox populi. 
It seems now, that no feature can be added, without some persons heavily
objecting it. That's sad, because this will slow down development. Every
improvement has to undergo a long road of justification, because one can always
find reasons against it.

And if there is already an extension to restore the original behaviour (is it?),
where is the problem?
Comment 49 Michael Lefevre 2003-08-08 18:42:55 PDT
FWIW, I think bucking the trend of Windows UI isn't a great move. I can see the
arguments for doing it on Windows XP, but there are still a lot of users of
Win98 and 2000. But my personal opinion isn't why I was adding to this bug...

Isn't there something of a security issue here? As of a couple of versions ago,
IE actually forces the IE name into all windows it generates (previously it
could be removed by script).  If Firebird doesn't put its name in the title bar,
doesn't that make it easy for a web page to pop up a window that pretends to be
some other app?  If a user can't tell the difference between a Firebird window
displaying a web page, and their AOL logon window, that's playing into the hands
of numerous password "phishers".

The suggested compromise now that there's a cleaner way of making this Windows
only seems like a good idea.
Comment 50 basic 2003-08-08 19:24:42 PDT
personally I like the the new titlebar (I'm a win2k user), as far as
acessibility is concern, the "Firebird" should probably be available to screen
readers and whatnots. Though I have a feeling that it is impossible to make a
browser that will fit all type of users (visual, text, braille, speech,...). If
there are people who are interested in doing that, they might want to create
either extensions or even their own special browser based on gecko.
Comment 51 Mike Connor [:mconnor] 2003-08-08 19:49:15 PDT
Hyatt, it makes a lot of sense to do it that way, if we want to continue with
the Windows convention.  Personally, as a Windows user, I'd rather you not do it
since I agree with you about how it looks, but that's certainly a viable
solution that satisfies most of this.

And Bernd, I agree completely, freedom to innovate is inversely proportional to
the number of people who have a say in the end product.

Comment 52 Bill Mason 2003-08-09 00:53:17 PDT
Well I kept my word and took myself off this bug only to hear I was being
misconstrued, so I'm back.

"Only because Bill Mason doesn't like the new behaviour"

Actually, I personally couldn't care if the old or new way is used.  When I
first saw it changed it looked odd, but 5 minutes later I didn't care.  My
argument here was to support the valid point raised that the change causes
accessibility issues.  That's been decided on and laid to rest, so I'm not
belaboring it.

"and maybe some others from mozillazine don't either, that does not mean it's
vox populi."

Vox populi literally means "voice of the people."  I still have not seen where
there were Macintosh users voicing that the old behavior was a problem.  None of
them writing extensions to take the text out of the title bar.  There certainly
have been plenty of Windows users voicing an opinion about the new, and the
extension does exist for those who really are hung up on the whole thing.

"It seems now, that no feature can be added,"

To define removing a portion of the UI functionality, however small, as 'adding
a feature' is a misrepresentation.

"without some persons heavily objecting it. That's sad, because this will slow
down development. Every improvement has to undergo a long road of justification,
because one can always find reasons against it."

To call it an improvement is obviously something that people would debate as well.

I actually think this instance has been a short, straightforward road.  A change
was made to create a cross-platform consistency that satisfies the developer's
aesthetic and uses the cleanest coding possible.  It was done, it was aired out
publically afterward, the call was made that it's a WONTFIX to reverse it. 
Done.  If only more debates (and decisions) in Bugzilla were handled as decisively.

That's why I actually feel that David's suggestion in comment 46 shouldn't be
done.  If what we have now satisfies the needs as defined by the developer, then
let that be it.  If avoiding IFDEF is the key to making it work, then just don't
do it.  Otherwise, philosophically, you just undermine your own argument and
you're back to 'this has been done because it looks prettier on the Mac' and
hearing 'but you're ignoring the traditional Windows style' in reply ad
infinitum.  Frankly, I'd rather hear that the change is because it creates less
spaghetti code than the alternatives, and that's the end.

"And if there is already an extension to restore the original behaviour (is it?),"

Yes, it does exist.  I've tried it and it works fine.
http://forums.mozillazine.org/viewtopic.php?p=144430#144430

"where is the problem?"

Which brings us back and ends us with: I didn't have one. You just
mischaracterized what I said.
Comment 53 Mikael Winterkvist 2003-08-09 02:31:40 PDT
I just got a call from a friend. She´s blind and is using various type of
equipment, among two of them reads the text on the screen. She really likes
Mozilla Firebird and I have helped her getting it to do what she wants it to do
and she´s pleased to having been able to replace her old Netscape browser. In
fact she´s so into Firebird that she spends some time reading the forums. 

She now called me asking if it was true that the new build had droped the name
out of the titlebar. I had to tell that it was so. She then explained to me that
she will not be able to use Firebird anymore since it actually will be very
heard for her to know what Windows she´s in. That´s why some of her programs in
her computer has been replaced with software that does have their name in the
title bar - among them Windows Explorer.

Her last question was if the decission was final and my reply was - I sincerely
hope not. Now what do you expect me to tell her? That the name was droped due to
some lines of code?

And she´s not alone and personally I think it´s really sad that Mozilla Firebird
will, or could be, known for being a browser that blind people can not use. This
is a matter of acessability and not to shut users out.

My two cents on the subject...
Comment 54 David Hyatt 2003-08-09 02:52:54 PDT
I'm investigating the accessibility issue after new information that some screen
readers possibly strip the name from the end of the title bar and read it
*first* when viewing window names.  Stay tuned.

Reopening for now.
Comment 55 David Hyatt 2003-08-09 02:57:55 PDT
It may be worthwhile having this be part of an "accessibility pack" or some such
to avoid the visual clutter otherwise.  It may be that an extension is still the
right place for this feature (as someone pointed out, I really want to avoid
#ifdefs in this title code and just have cross-platform consistency in the
default Firebird application).

Anyway, I'll keep this open for now while this is being investigated.
Comment 56 David Hyatt 2003-08-09 03:04:36 PDT
It may also be possible to feed the "- Mozilla Firebird" to screen readers
somehow without it being visually rendered.  If possible, I'd like more
information (e.g., the specific reader being used).
Comment 57 Mikael Winterkvist 2003-08-09 03:31:00 PDT
After having written my comment I got the information about an extension that
put Mozilla Firebird back. I have tested it and it works fine. I will off course
help my friend to install it and at the same time upgrade her Firebird :-)
Comment 58 Henrik Hallin 2003-08-09 03:49:29 PDT
Its a very bad and extremely strange idea to remove the "- Mozilla Firebird"
from the title bar. The browser got anonymous for people who dont know about
Firebird. It will be harder to promote the browser to the rest of the world when
the people cant see the name an memorize it together with the gui. Its now the
same thing with Thunderbird - "The anonymous mail client from Mozilla.org".
Embarrassing.
Comment 59 Voyager 2003-08-09 14:20:13 PDT
I suggest that the "Product" line reflect Firebird AND Thunderbird, since the
same is true for the latest Thunderbird build.  My vote on this will depend on
the future plans of Mozilla.

In general, I believe that it's a terrible idea to leave an application without
its title in the window some place.  While I agree that one rarely looks at the
application name and that while on the taskbar, the name is most of the times
invisible.  However, the name *is* visible when one mouses over the task bar
icon.  Annonymous applications are not just a deviation from the norm but also a
roadblock towards marketing.

Now if it is being left out to prepare for integration in Mozilla, i.e. the name
"Mozilla" will eventually take the spot, then go ahead.  I can live with no
names for a while.
Comment 60 shadytrees 2003-08-10 10:00:17 PDT
Shouldn't summary be changed to "Removing '- Mozilla Firebird' breaks screen
readers"?
Comment 61 Aaron Leventhal 2003-08-11 02:09:37 PDT
I had to test to be sure -- this makes the JAWS screen reader (which has 
around 90% of the screen reader market) not say the name of the application 
when it is switched to. Yes, this is important for usability of a screen 
reader. Screen reader vendors are not going to insert special case code for 
Mozilla apps, to speak the application name.

However, since a lot of people like the new shortened title bars, maybe we can 
compromise. We can test for the presence of a screen reader and put the 
application name in the title bar only when a screen reader is running.

I'm not sure how to do this on *nix, but this works for windows:

    PRBool isScreenReaderActive = PR_FALSE;
#ifdef XP_WIN
    ::SystemParametersInfo(SPI_GETSCREENREADER, 0, &isScreenReaderActive, 0);
#endif

BTW, this is technically not a section 508 violation, because the name of the 
application is still exposed, just not through the title bar. It can still be 
gleaned from other OS APIs. The section 508 guidelines don't specify what API 
things have to be exposed through.

Changing summary to reflect that.
Comment 62 Aaron Leventhal 2003-08-11 02:50:01 PDT
Forgot to respond to Hyatt's comments -

* On Mac there is no screen reader, so for accessibility it doesn't matter 
what we do there.
* When JAWS is used with Windows Explorer it says "folder view" after the name 
of the folder. I believe this is due to JAWS checking the window content.
* As far as ISP's occasionally taking over the title bar, I suppose that's 
true in the minority of cases

If someone wants to file a separate bug on exposing the name of the 
application when a screen reader is present, IMO that's probably good enough 
for now, rather than keep this bug open for accessibility reasons.
Comment 63 David Hyatt 2003-08-11 18:54:14 PDT
Changing summary to reflect Aaronl's comments and targeting for Firebird 0.7. 
I'll hook up code that checks for the presence of a screen reader and make sure
the title gets modified appropriately.


Comment 64 David Hyatt 2003-08-11 18:58:30 PDT
Plan of attack:
(1) Put titleseparator back into the XUL for Firebird and Thunderbird.
(2) On Win32 only, check for the presence of a screen reader.  If it's active,
then treat titledefault like titlemodifier.
(3) Make sure the code doesn't append the modifier or separator if the modifier
is empty.
Comment 65 David Hyatt 2003-08-11 19:21:02 PDT
Created attachment 129632 [details] [diff] [review]
Patch to check for screen readers and do the right thing with the title.

This should not affect Seamonkey at all, since it doesn't use the titledefault
mechanism.
Comment 66 David Hyatt 2003-08-11 19:31:33 PDT
The problem with this patch is it only deals with browser windows.  Mail was building up 
the title by hand using JS.

I think there's no choice but to just put this back the way it was and add #ifndef 
XP_MACOSX code.
Comment 67 David Hyatt 2003-08-11 19:48:47 PDT
Created attachment 129634 [details] [diff] [review]
Patch to make only the Mac (and only in Fb/Tb) drop the modifier.

Ok, this patch makes sure Mac-only and Tb/Fb/New Xul Apps do the right thing
with title bars while leaving WIn32 and Linux alone.
Comment 68 Brian Ryner (not reading) 2003-08-11 19:52:39 PDT
Comment on attachment 129634 [details] [diff] [review]
Patch to make only the Mac (and only in Fb/Tb) drop the modifier.

r=bryner with the change we discussed on irc (change to #if defined(XP_MACOSX)
&& defined(MOZ_XUL_APP))
Comment 69 Brendan Eich [:brendan] 2003-08-11 22:24:41 PDT
Comment on attachment 129634 [details] [diff] [review]
Patch to make only the Mac (and only in Fb/Tb) drop the modifier.

what bryner said, and sr=brendan@mozilla.org.

/be
Comment 70 Asa Dotzler [:asa] 2003-08-11 22:39:07 PDT
Comment on attachment 129634 [details] [diff] [review]
Patch to make only the Mac (and only in Fb/Tb) drop the modifier.

a=asa (on behalf of drivers) for checkin to Mozilla 1.5beta.
Comment 71 David Hyatt 2003-08-11 22:51:58 PDT
Fixed.  See, no decision is really final. :)

Comment 72 Ivan Sagalaev 2003-08-12 00:46:25 PDT
I hope so... It was classy, user friendly and just beautiful to show a single
page title without a shameless self-advertising. Remember AOL? They also used to
put their 3 letter everywhere on the computer. 

I wonder if we end up with the behaviour of a known software vendor which
includes abbreviation 'MS' in every app's name as many times as possible :-)
Comment 73 David Hyatt 2003-08-12 13:00:32 PDT
What can I say? Switch to Mac. ;)
Comment 74 Michael Schaap 2003-08-12 14:51:31 PDT
I know I'm a bit late with my comment, but since there are such strong feelings
on either side, shouldn't it just be made an option whether " - Appname" is
included in the titlebar?  That way:
 - People can change it easily to their liking
 - Default can be set appropriate for the platform (Mac off, rest on)
 - No #ifdef in the XUL required

Just my € 0.02,

 - Michael
Comment 75 Nicholas Avenell 2003-08-12 23:28:38 PDT
Just for completeness, I should point out that the lack of app name in the title
attribute also breaks speech control programs (Dragon Simply Speaking, for
example) that allow you to use "Switch to $FOO", where foo is part of the title
of the window.
Comment 76 MORA 2003-08-13 02:40:25 PDT
Thanks for restoring the title. While I can understand that some people actually 
liked the 'feature', I really believe that UI consistency is more important. 
Every Windows program I know has its title displayed; removing the title was 
therefore non-standard UI behavior. 

I hope the lesson of this will be that any deviations from standard UI features 
need to be evaluated more carefully before being applied in practice. If, as in 
this case, some people appear to prefer the non-standard behavior, it should be 
made available as an option or extension, not a default setting. Unless there 
are _real_ compelling reasons, non-standard UI features should _not_ be part of 
the program defaults, in my opinion.

Anyway, while this mess could have been avoided I appreciate that the developers
took appropriate action. Thank you for listening and for having the courage to
admit a mistake. :)
Comment 77 Michael Lefevre 2003-08-13 03:37:52 PDT
Francis - 
"I hope the lesson of this will be that any deviations from standard UI features 
need to be evaluated more carefully before being applied in practice."

This wasn't "applied" to any releases - evaluating things is what the nightly
builds are for. If you only want to see changes after they've been evaluated
more carefully, stick to the release builds.

anyway, it's back. Let's not waste any more time discussing it. Verified fixed.

Note You need to log in before you can comment on or make changes to this bug.